package com.acme.data.hibernatereactive.repository.config;

import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.Import;
import org.springframework.core.annotation.AliasFor;

import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

@Retention(RetentionPolicy.RUNTIME)
@Import(HibernateReactiveRepositoriesRegistrar.class)
public @interface EnableHibernateReactiveRepositories {

    ComponentScan.Filter[] includeFilters() default {};

    ComponentScan.Filter[] excludeFilters() default {};

    String namedQueriesLocation() default "";

    String repositoryImplementationPostfix() default "Impl";

    @AliasFor("basePackages")
    String[] value() default {};

    @AliasFor("value")
    String[] basePackages() default {};

    Class<?>[] basePackageClasses() default {};

    Class<?> repositoryFactoryBeanClass() default HibernateReactiveRepositoryFactoryBean.class;
}
