package com.acme.data.hibernatereactive.repository.config;

import com.acme.data.hibernatereactive.repository.support.SimpleHibernateReactiveRepository;
import org.hibernate.reactive.mutiny.Mutiny;
import org.springframework.data.repository.core.EntityInformation;
import org.springframework.data.repository.core.RepositoryInformation;
import org.springframework.data.repository.core.RepositoryMetadata;
import org.springframework.data.repository.core.support.ReactiveRepositoryFactorySupport;

public class HibernateReactiveRepositoryFactory extends ReactiveRepositoryFactorySupport {

    private final Mutiny.SessionFactory sf;

    public HibernateReactiveRepositoryFactory(Mutiny.SessionFactory sf) {
        this.sf = sf;
    }

    @Override
    public <T, ID> EntityInformation<T, ID> getEntityInformation(Class<T> domainClass) {
        return null;
    }

    @Override
    protected Object getTargetRepository(RepositoryInformation repositoryInformation) {
        Object[] argsForRepositoryConstructor = new Object[]{repositoryInformation, sf};
        // instantiate the repository by reflexion
        // implementation type is guessed from metadata (@EnableHibernateReactiveRepositories.repositoryFactoryBeanClass)
        // argsForRepositoryConstructor must match with the constructor signature
        Object repository = getTargetRepositoryViaReflection(repositoryInformation, argsForRepositoryConstructor);

        return repository;
    }

    @Override
    protected Class<?> getRepositoryBaseClass(RepositoryMetadata metadata) {
        return SimpleHibernateReactiveRepository.class;
    }
}
