package com.acme.data.hibernatereactive.repository.config;

import org.hibernate.reactive.mutiny.Mutiny;
import org.springframework.data.repository.Repository;
import org.springframework.data.repository.core.support.RepositoryFactoryBeanSupport;
import org.springframework.data.repository.core.support.RepositoryFactorySupport;

public class HibernateReactiveRepositoryFactoryBean <T extends Repository<S, ID>, S, ID> extends RepositoryFactoryBeanSupport<T, S, ID> {
    private final Mutiny.SessionFactory sf;

    // constructor can receive any bean present in the application context
    protected HibernateReactiveRepositoryFactoryBean(Class<? extends T> repositoryInterface, Mutiny.SessionFactory sf) {
        super(repositoryInterface);
        this.sf = sf;
    }

    @Override
    protected RepositoryFactorySupport createRepositoryFactory() {
        return new HibernateReactiveRepositoryFactory(sf);
    }
}
