drop view if exists Member_comments;
drop table if exists Book_comments;
drop table if exists Reservation;
drop table if exists Member_Category;
drop table if exists Book;
drop table if exists Author;
drop table if exists Member;
drop table if exists Category;

create table Category (
    id int GENERATED BY DEFAULT AS IDENTITY primary key,
    name varchar(255)
);

create table Author (
    id int GENERATED BY DEFAULT AS IDENTITY primary key,
    firstname varchar(255),
    lastname varchar(255)
);

create table Book (
    id int GENERATED BY DEFAULT AS IDENTITY primary key,
    title varchar(255),
    author_id int references Author(id),
    category_id int references Category(id)
);

create table Member (
    id int GENERATED BY DEFAULT AS IDENTITY primary key,
    firstname varchar(255),
    lastname varchar(255),
    username varchar(255) unique,
    password varchar(255)
);
create index on Member (username);

create table Book_comments (
    Book_id int not null references Book(id) ON DELETE CASCADE,
    Member_id int references Member(id),
    date timestamp,
    text varchar(2000)
);

create view Member_comments as select * from Book_comments;

create table Member_Category (
    Member_id int not null references Member(id),
    preferences_id int not null references Category(id)
);

create table Reservation (
    id int GENERATED BY DEFAULT AS IDENTITY primary key,
    pickupDate date,
    returnDate date,
    book_id int references Book(id),
    member_id int references Member(id)
);

insert into category (name) values ('Essay');
insert into category (name) values ('Novel');
insert into category (name) values ('Poetry');
insert into category (name) values ('Biography');


insert into author (firstname, lastname) values ('Henry David', 'Thoreau');
insert into author (firstname, lastname) values ('Joseph', 'Conrad');
insert into author (firstname, lastname) values ('Jack', 'London');
insert into author (firstname, lastname) values ('William', 'Faulkner');
insert into author (firstname, lastname) values ('Walt', 'Withman');

insert into book (title, author_id, category_id) values ('Walden', 1, 1);
insert into book (title, author_id, category_id) values ('Heart of darkness', 2, 2);
insert into book (title, author_id, category_id) values ('Martin Eden', 5, 4);
insert into book (title, author_id, category_id) values ('The Sound and the Fury', 3, 2);
insert into book (title, author_id, category_id) values ('Leaves of Grass', 4, 3);

insert into Member(firstname, lastname, username, password) values('John', 'Doe', 'jdoe', '$2a$10$oZsxPNZFQmLO9HaJNAElJuCF1OPoRKMf2T2S1Of/MWRm1FWMyXELe');

insert into Book_comments(book_id, member_id, date, text) values(1,1, now(), 'Lorem ipsum...');